﻿Type=Activity
Version=7.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	Dim Debug As Boolean
End Sub

'These links may be helpful in understanding achievements and leaderboards:
'https://developers.google.com/games/services/android/achievements
'https://developers.google.com/games/services/android/leaderboards

'----- IMPORTANT ----- IMPORTANT ----- IMPORTANT ----- IMPORTANT ----- IMPORTANT -----
'
' THIS APPLICATION SELECTS ACHIEVEMENTS AMONG THE EXISTING ACHIEVEMENTS AND ALLOWS
' TO UNLOCK THEM, SO USE IT ONLY WITH ACHIEVEMENTS CREATED FOR TESTS (OR DO NOT CLICK
' ON THE INCREMENT OR UNLOCK BUTTONS).
'
' THIS APPLICATION SELECTS A LEADERBOARD AMONG THE EXISTING LEADERBOARDS AND ALLOWS
' TO ADD FAKE SCORES, SO USE IT ONLY WITH LEADERBOARDS CREATED FOR TESTS (OR DO NOT
' CLICK ON THE ADD_SCORE BUTTON).
'
'-------------------------------------------------------------------------------------

Sub Globals
	Dim Connection As ClsConnection
	Dim GPUtils As GPlayUtils

	Dim btnSignIn, btnSignOut As Button
	Dim lblAchievements, lblLeaderboards As Label
	Dim btnOpenAchievementsDlg, btnIncrementAchievement, btnUnlockAchievement As Button
	Dim btnOpenLeaderboardsDlg, btnAddScore, btnDisplayTop10 As Button
	Dim PBSpinner As ProgressBar

	Dim Achievements As GPlayAchievements
	Dim AchievementToUnlock_Id As String
	Dim AchievementWithSteps_Id As String
	Dim AchievementWithSteps_Name As String

	Dim Leaderboards As GPlayLeaderboards
	Dim Leaderboard_Id As String
	Dim str10Scores As String

	Dim ACHIEVEMENTS_DLG As String = "Achievements"
	Dim LEADERBOARDS_DLG As String = "Leaderboards"
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Initializes the Connection class (with debug mode enabled)
	Debug = True
	Connection.Initialize(True, False, False, Me, "Connection_Success", "Connection_Failure", True, Debug)

	'Adds a few buttons
	btnSignIn.Initialize("btnSignIn")
	btnSignIn.Text = "Sign in"
	Activity.AddView(btnSignIn, 10dip, 10dip, 110dip, 60dip)

	btnSignOut.Initialize("btnSignOut")
	btnSignOut.Text = "Sign out"
	Activity.AddView(btnSignOut, 120dip, 10dip, 110dip, 60dip)

	lblAchievements.Initialize("")
	lblAchievements.Text = "---- Achievements ---------"
	Activity.AddView(lblAchievements, 10dip, 80dip, 150dip, 60dip)

	btnOpenAchievementsDlg.Initialize("btnOpenAchievementsDlg")
	btnOpenAchievementsDlg.Text = "Dialog"
	Activity.AddView(btnOpenAchievementsDlg, 10dip, 110dip, 110dip, 60dip)

	btnIncrementAchievement.Initialize("btnIncrementAchievement")
	btnIncrementAchievement.Text = "Increment"
	Activity.AddView(btnIncrementAchievement, 120dip, 110dip, 110dip, 60dip)

	btnUnlockAchievement.Initialize("btnUnlockAchievement")
	btnUnlockAchievement.Text = "Unlock"
	Activity.AddView(btnUnlockAchievement, 230dip, 110dip, 110dip, 60dip)

	lblLeaderboards.Initialize("")
	lblLeaderboards.Text = "---- Leaderboards ----------"
	Activity.AddView(lblLeaderboards, 10dip, 180dip, 150dip, 60dip)

	btnOpenLeaderboardsDlg.Initialize("btnOpenLeaderboardsDlg")
	btnOpenLeaderboardsDlg.Text = "Dialog"
	Activity.AddView(btnOpenLeaderboardsDlg, 10dip, 210dip, 110dip, 60dip)

	btnAddScore.Initialize("btnAddScore")
	btnAddScore.Text = "Add score"
	Activity.AddView(btnAddScore, 120dip, 210dip, 110dip, 60dip)

	btnDisplayTop10.Initialize("btnDisplayTop10")
	btnDisplayTop10.Text = "Top 10"
	Activity.AddView(btnDisplayTop10, 230dip, 210dip, 110dip, 60dip)

	'Initializes the spinner
	PBSpinner.Initialize("")
	PBSpinner.Indeterminate = True
	PBSpinner.Visible = False
	Activity.AddView(PBSpinner, 50%x - 30dip, 50%y - 30dip, 60dip, 60dip)
End Sub

Sub Activity_Resume
	'Auto-reconnects to Google Play services if disconnected
	Connection.AutoConnect

	'Updates the button states
	Update_UI
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	'Signs the user out and disconnects the Games client
	If UserClosed Then
		Connection.SignOutAndDisconnect
	End If
End Sub

Sub Connection_Failure(Error As typError)
	'Displays the error message returned by the Connection class
	If Error.Error = Connection.ERROR_NO_NETWORK Then
		Msgbox("You are not connected to a data network. Please enable your wifi or mobile connection.", "No data network")
	Else If Error.Error = Connection.ERROR_SIGNIN_FAILED AND Error.Code = GPUtils.ACTIVITY_RESULT_CANCELED Then
		LogColor("Connection_Failure: the sign-in dialog has been cancelled by the user.", Colors.Red)
	Else
		Msgbox(Error.Msg & CRLF & "Error=" & Error.Error & " Code=" & Error.Code, "Error")
	End If

	'Updates the button states
	Update_UI
End Sub

Sub Connection_Success(Success As Byte)
	If Success = Connection.SUCCESS_SIGNIN Then
		'Initializes the Achievements and Leaderboards classes
		Achievements.Initialize
		Leaderboards.Initialize

		'Loads the list of achievements
		PBSpinner.Visible = True
		Achievements.Load(False).SetResultEvent("GP_onAchievementsLoaded")

		'Loads the list of leaderboards
		PBSpinner.Visible = True
		Leaderboards.LoadLeaderboardMetadata(False).SetResultEvent("GP_onLeaderboardsLoaded")
	End If

	'Updates the button states
	Update_UI
End Sub

Sub GP_onAchievementsLoaded(Result As Map)
	PBSpinner.Visible = False
	Dim StatusCode As Int = Result.Get(Achievements.RESULTMAP_STATUS_CODE)
	If StatusCode <> Achievements.STATUS_OK Then
		'The loading failed
		Msgbox("Load: Error=" & StatusCode, "Error")
		Return
	End If

	'Gets the list of achievements
	Dim arrAchievement() As GPlayAchievement = Result.Get(Achievements.RESULTMAP_ACHIEVEMENTS)

	'Selects a hidden achievement and an incremental achievement
	AchievementToUnlock_Id = "": AchievementWithSteps_Id = ""
	For i = 0 To arrAchievement.Length - 1
		If Debug Then Log("Achievement """ & arrAchievement(i).Name & """: " & arrAchievement(i).Type & " " & arrAchievement(i).Description)
		If arrAchievement(i).Type = arrAchievement(i).TYPE_STANDARD _
			AND arrAchievement(i).State = arrAchievement(i).STATE_HIDDEN Then
			AchievementToUnlock_Id = arrAchievement(i).AchievementId
		Else If arrAchievement(i).Type = arrAchievement(i).TYPE_INCREMENTAL Then
			If Debug Then Log("  Current steps: " & arrAchievement(i).CurrentSteps & " / Total steps: " & arrAchievement(i).TotalSteps)
			If arrAchievement(i).CurrentSteps < arrAchievement(i).TotalSteps Then
				AchievementWithSteps_Id = arrAchievement(i).AchievementId
				AchievementWithSteps_Name = arrAchievement(i).Name
			End If
		End If
	Next

	'Updates the button states
	Update_UI
End Sub

Sub GP_onLeaderboardsLoaded(Result As Map)
	PBSpinner.Visible = False
	Dim StatusCode As Int = Result.Get(Leaderboards.RESULTMAP_STATUS_CODE)
	If StatusCode <> Leaderboards.STATUS_OK Then
		'The loading failed
		Msgbox("LoadLeaderboardMetadata: Error=" & StatusCode, "Error")
		Return
	End If

	'Gets the list of leaderboards
	Dim arrLeaderboard() As GPlayLeaderboard = Result.Get(Leaderboards.RESULTMAP_LEADERBOARDS)

	'Selects a leaderboard
	Leaderboard_Id = ""
	For i = 0 To arrLeaderboard.Length - 1
		If Debug Then Log("Leaderboard """ & arrLeaderboard(i).DisplayName & """: " & arrLeaderboard(i).Variants.Size)
		Leaderboard_Id = arrLeaderboard(i).LeaderboardId
	Next

	'Updates the button states
	Update_UI
End Sub

Sub btnSignIn_Click
	'Signs the user in
	KeepScreenOn(True)
	Connection.SignIn
End Sub

Sub btnSignOut_Click
	'Signs the user out
	Connection.SignOut
	KeepScreenOn(False)
End Sub

Sub btnOpenAchievementsDlg_Click
	'Opens the dialog to see achievements
	Dim i As Intent = Achievements.GetAchievementsIntent
	GPUtils.StartActivityForResult(i, ACHIEVEMENTS_DLG)
End Sub

Sub btnOpenLeaderboardsDlg_Click
	'Opens the dialog to see leaderboards
	Dim i As Intent = Leaderboards.GetAllLeaderboardsIntent
	GPUtils.StartActivityForResult(i, LEADERBOARDS_DLG)
End Sub

Sub GPC_onActivityResult(ID As String, ResultCode As Int, ResultIntent As Object)
	If Debug Then LogColor("GPC_onActivityResult: " & ID & " " & ResultCode & " " & ResultIntent, Colors.Blue)
	If ResultCode = GPUtils.ACTIVITY_RESULT_RECONNECT_REQUIRED Then
		'The user signed out in the Settings dialog
		Connection.GPC.Disconnect(False)
		Update_UI
	End If
End Sub

Sub btnIncrementAchievement_Click
	'Increments an achievement by 1
	PBSpinner.Visible = True
	Achievements.IncrementImmediate(AchievementWithSteps_Id, 1).SetResultEvent("GP_onAchievementIncremented")
End Sub

Sub GP_onAchievementIncremented(Result As Map)
	PBSpinner.Visible = False
	Dim StatusCode As Int = Result.Get(Achievements.RESULTMAP_STATUS_CODE)
	If StatusCode <> Achievements.STATUS_OK Then
		'The achievement update failed
		Msgbox("IncrementImmediate: Error=" & StatusCode, "Error")
		Return
	End If

	'+1 step
	ToastMessageShow(AchievementWithSteps_Name & ": +1 step", False)

	'Selects another incremental achievement to unlock (or the same achievement if current steps < total steps)
	PBSpinner.Visible = True
	Achievements.Load(False).SetResultEvent("GP_onAchievementsLoaded")
End Sub

Sub btnUnlockAchievement_Click
	'Unlocks an achievement
	PBSpinner.Visible = True
	Achievements.UnlockImmediate(AchievementToUnlock_Id).SetResultEvent("GP_onAchievementUnlocked")
End Sub

Sub GP_onAchievementUnlocked(Result As Map)
	PBSpinner.Visible = False
	Dim StatusCode As Int = Result.Get(Achievements.RESULTMAP_STATUS_CODE)
	If StatusCode <> Achievements.STATUS_OK Then
		'The achievement update failed
		Msgbox("UnlockImmediate: Error=" & StatusCode, "Error")
		Return
	End If

	'Selects another hidden achievement to unlock
	PBSpinner.Visible = True
	Achievements.Load(False).SetResultEvent("GP_onAchievementsLoaded")
End Sub

Sub btnAddScore_Click
	'Submits a random score to the selected leaderboard
	PBSpinner.Visible = True
	Leaderboards.SubmitScoreImmediate(Leaderboard_Id, Rnd(10, 10000)).SetResultEvent("GP_onScoreSubmitted")
End Sub

Sub GP_onScoreSubmitted(Result As Map)
	PBSpinner.Visible = False
	Dim StatusCode As Int = Result.Get(Achievements.RESULTMAP_STATUS_CODE)
	If StatusCode <> Leaderboards.STATUS_OK Then
		'The score submission failed
		Msgbox("SubmitScoreImmediate: Error=" & StatusCode, "Error")
		Return
	End If

	'New best score ?
	Dim Score As GPlayScoreSubmissionData = Result.Get(Leaderboards.RESULTMAP_SCORE_DATA)
	If Score.IsNewBest(Score.TIME_SPAN_ALL_TIME) Then
		ToastMessageShow("Added. New best score=" & Score.GetFormattedScore(Score.TIME_SPAN_ALL_TIME), False)
	Else
		ToastMessageShow("Unchanged. Current score=" & Score.GetFormattedScore(Score.TIME_SPAN_ALL_TIME), False)
	End If
End Sub

Sub btnDisplayTop10_Click
	'Gets the first 10 scores of the selected leaderboard
	'In this demo, 5 scores are retrieved here, then the next 5 in GP_onScoresLoaded to show how to use LoadMoreScores.
	'In your app, you could retrieve the 10 scores in one call (up to 25).
	PBSpinner.Visible = True
	Leaderboards.LoadTopScores(Leaderboard_Id, Leaderboards.TIME_SPAN_ALL_TIME, Leaderboards.COLLECTION_SOCIAL, 5).SetResultEvent("GP_onScoresLoaded")
End Sub

Sub GP_onScoresLoaded(Result As Map)
	PBSpinner.Visible = False
	Dim StatusCode As Int = Result.Get(Achievements.RESULTMAP_STATUS_CODE)
	If StatusCode <> Leaderboards.STATUS_OK Then
		'The score loading failed
		Msgbox("LoadTopScores: Error=" & StatusCode, "Error")
		Return
	End If

	'Fills a string with the first 5 scores
	Dim arrScores() As GPlayLeaderboardScore = Result.Get(Leaderboards.RESULTMAP_SCORES)
	str10Scores = ""
	For i = 0 To arrScores.Length - 1
		Dim Score As GPlayLeaderboardScore = arrScores(i)
		If i > 0 Then str10Scores = str10Scores & CRLF
		str10Scores = str10Scores & Score.DisplayRank & ". " & Score.DisplayScore & " _ " & Score.ScoreHolderDisplayName
	Next

	'Gets the next 5 scores
	Dim Buffer As Object = Result.Get(Leaderboards.RESULTMAP_SCORE_BUFFER)
	Leaderboards.LoadMoreScores(Buffer, 5, Leaderboards.PAGE_DIRECTION_NEXT).SetResultEvent("GP_onMoreScoresLoaded")
End Sub

Sub GP_onMoreScoresLoaded(Result As Map)
	PBSpinner.Visible = False
	Dim StatusCode As Int = Result.Get(Achievements.RESULTMAP_STATUS_CODE)
	If StatusCode <> Leaderboards.STATUS_OK Then
		'The score loading failed
		Msgbox("LoadMoreScores: Error=" & StatusCode, "Error")
		Return
	End If

	'Completes the score string and displays it
	Dim arrScores() As GPlayLeaderboardScore = Result.Get(Leaderboards.RESULTMAP_SCORES)
	str10Scores = ""
	For i = 0 To arrScores.Length - 1
		Dim Score As GPlayLeaderboardScore = arrScores(i)
		If i > 0 Then str10Scores = str10Scores & CRLF
		str10Scores = str10Scores & Score.DisplayRank & ". " & Score.DisplayScore & " _ " & Score.ScoreHolderDisplayName
	Next
	Msgbox(str10Scores, "Top 10")
End Sub

Sub Update_UI
	'Updates the state of buttons
	btnSignIn.Enabled = Not(Connection.IsSignedIn)
	btnSignOut.Enabled = Connection.IsSignedIn
	btnOpenAchievementsDlg.Enabled = Connection.IsSignedIn
	btnIncrementAchievement.Enabled = Connection.IsSignedIn And AchievementWithSteps_Id <> ""
	btnUnlockAchievement.Enabled = Connection.IsSignedIn And AchievementToUnlock_Id <> ""
	btnOpenLeaderboardsDlg.Enabled = Connection.IsSignedIn
	btnAddScore.Enabled = Connection.IsSignedIn And Leaderboard_Id <> ""
	btnDisplayTop10.Enabled = Connection.IsSignedIn And Leaderboard_Id <> ""
End Sub

Sub KeepScreenOn(IsEnabled As Boolean)
	'Prevents the screen from sleeping when the current Activity is in the foreground
	Dim r As Reflector
	r.Target = r.GetActivity
	r.Target = r.RunMethod("getWindow")
	Dim FLAG_KEEP_SCREEN_ON As Int = 128
	If IsEnabled Then
		r.RunMethod2("addFlags", FLAG_KEEP_SCREEN_ON, "java.lang.int")
	Else
		r.RunMethod2("clearFlags", FLAG_KEEP_SCREEN_ON, "java.lang.int")
	End If
End Sub
